Package org.pushingpixels.substance.internal.utils

# Class SubstanceInternalFrameTitlePane

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.plaf.basic.BasicInternalFrameTitlePane
org.pushingpixels.substance.internal.utils.SubstanceInternalFrameTitlePane

All Implemented Interfaces:
  `ImageObserver`, `MenuContainer`, `Serializable`

public class SubstanceInternalFrameTitlePane extends BasicInternalFrameTitlePane
UI for internal frame title pane in Substance look and feel.

See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`SubstanceInternalFrameTitlePane.ClickListener`
Click correction listener that resets models of minimize and restore buttons on click (so that the rollover behaviour will be preserved correctly).
`class`
`SubstanceInternalFrameTitlePane.SubstanceIconifyAction`
Custom iconifying action.
`class`
`SubstanceInternalFrameTitlePane.SubstanceMenuBar`
Class responsible for drawing the system menu.
`protected class`
`SubstanceInternalFrameTitlePane.SubstanceTitlePaneLayout`
Layout manager for this title pane.

## Nested classes/interfaces inherited from class javax.swing.plaf.basic.BasicInternalFrameTitlePane

`BasicInternalFrameTitlePane.CloseAction, BasicInternalFrameTitlePane.IconifyAction, BasicInternalFrameTitlePane.MaximizeAction, BasicInternalFrameTitlePane.MoveAction, BasicInternalFrameTitlePane.PropertyChangeHandler, BasicInternalFrameTitlePane.RestoreAction, BasicInternalFrameTitlePane.SizeAction, BasicInternalFrameTitlePane.SystemMenuBar, BasicInternalFrameTitlePane.TitlePaneLayout`

## Nested classes/interfaces inherited from class javax.swing.JComponent

`JComponent.AccessibleJComponent`

## Nested classes/interfaces inherited from class java.awt.Container

`Container.AccessibleAWTContainer`

## Nested classes/interfaces inherited from class java.awt.Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected static final String`
`ICONIFYING`
Client property to mark an internal frame as being iconified.
`protected PropertyChangeListener`
`substancePropertyListener`
Listens on the changes to the internal frame title.
`protected PropertyChangeListener`
`substanceWinModifiedListener`
Listens to the changes to the `SubstanceLookAndFeel.WINDOW_MODIFIED` property on the internal frame and its root pane.
`protected static final String`
`UNINSTALLED`
Client property to mark a title pane as uninstalled.

### Fields inherited from class javax.swing.plaf.basic.BasicInternalFrameTitlePane

`CLOSE_CMD, closeAction, closeButton, closeIcon, frame, iconButton, iconIcon, ICONIFY_CMD, iconifyAction, maxButton, maxIcon, MAXIMIZE_CMD, maximizeAction, menuBar, minIcon, MOVE_CMD, moveAction, notSelectedTextColor, notSelectedTitleColor, propertyChangeListener, RESTORE_CMD, restoreAction, selectedTextColor, selectedTitleColor, SIZE_CMD, sizeAction, windowMenu`

### Fields inherited from class javax.swing.JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class java.awt.Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

## Constructor Summary

Constructors
Constructor
Description
`SubstanceInternalFrameTitlePane(JInternalFrame f)`
Simple constructor.

## Method Summary

Modifier and Type
Method
Description
`void`
`addNotify()`
`protected void`
`addSystemMenuItems(JMenu menu)`
Adds the necessary `JMenuItem`s to the specified menu.
`protected void`
`createActions()`
`protected void`
`createButtons()`
`protected LayoutManager`
`createLayout()`
`protected JMenu`
`createSystemMenu()`
Returns the `JMenu` displaying the appropriate menu items for manipulating the Frame.
`protected JMenuBar`
`createSystemMenuBar()`
Returns the `JMenuBar` displaying the appropriate system menu items.
`protected void`
`enableActions()`
`AbstractButton`
`getCloseButton()`
`DecorationAreaType`
`getThisDecorationType()`
`protected void`
`installDefaults()`
`protected void`
`installListeners()`
`void`
`paintComponent(Graphics g)`
`void`
`removeNotify()`
`void`
`setActive(boolean isActive)`
Updates state dependant upon the Window's active state.
`protected void`
`setButtonIcons()`
`protected void`
`syncCloseButtonTooltip()`
Synchronizes the tooltip of the close button.
`void`
`uninstall()`
Uninstalls `this` title pane.
`void`
`uninstallListeners()`

### Methods inherited from class javax.swing.plaf.basic.BasicInternalFrameTitlePane

`addSubComponents, assembleSystemMenu, createPropertyChangeListener, getTitle, installTitlePane, paintTitleBackground, postClosingEvent, showSystemMenu, uninstallDefaults`

### Methods inherited from class javax.swing.JComponent

`addAncestorListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getUI, getUIClassID, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintImmediately, paintImmediately, paramString, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update, updateUI`

### Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getAccessibleContext, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### substancePropertyListener

protected PropertyChangeListener substancePropertyListener
Listens on the changes to the internal frame title.

### substanceWinModifiedListener

protected PropertyChangeListener substanceWinModifiedListener
Listens to the changes to the `SubstanceLookAndFeel.WINDOW_MODIFIED` property on the internal frame and its root pane.

### ICONIFYING

protected static final String ICONIFYING
Client property to mark an internal frame as being iconified.

See Also:
  - Constant Field Values

### UNINSTALLED

protected static final String UNINSTALLED
Client property to mark a title pane as uninstalled.

See Also:
  - Constant Field Values

## Constructor Details

### SubstanceInternalFrameTitlePane

public SubstanceInternalFrameTitlePane(JInternalFrame f)
Simple constructor.

Parameters:
  `f` - Associated internal frame.

## Method Details

### installDefaults

protected void installDefaults()

Overrides:
  `installDefaults` in class `BasicInternalFrameTitlePane`

### installListeners

protected void installListeners()

Overrides:
  `installListeners` in class `BasicInternalFrameTitlePane`

### uninstallListeners

public void uninstallListeners()

Overrides:
  `uninstallListeners` in class `BasicInternalFrameTitlePane`

### uninstall

public void uninstall()
Uninstalls `this` title pane.

### setActive

public void setActive(boolean isActive)
Updates state dependant upon the Window's active state.

Parameters:
  `isActive` - if `true`, the window is in active state.

### enableActions

protected void enableActions()

Overrides:
  `enableActions` in class `BasicInternalFrameTitlePane`

### getThisDecorationType

public DecorationAreaType getThisDecorationType()

### paintComponent

public void paintComponent(Graphics g)

Overrides:
  `paintComponent` in class `BasicInternalFrameTitlePane`

### setButtonIcons

protected void setButtonIcons()

Overrides:
  `setButtonIcons` in class `BasicInternalFrameTitlePane`

### createSystemMenuBar

protected JMenuBar createSystemMenuBar()
Returns the `JMenuBar` displaying the appropriate system menu items.

Overrides:
  `createSystemMenuBar` in class `BasicInternalFrameTitlePane`
Returns:
  `JMenuBar` displaying the appropriate system menu items.

### createActions

protected void createActions()

Overrides:
  `createActions` in class `BasicInternalFrameTitlePane`

### createSystemMenu

protected JMenu createSystemMenu()
Returns the `JMenu` displaying the appropriate menu items for manipulating the Frame.

Overrides:
  `createSystemMenu` in class `BasicInternalFrameTitlePane`
Returns:
  `JMenu` displaying the appropriate menu items for manipulating the Frame.

### addSystemMenuItems

protected void addSystemMenuItems(JMenu menu)
Adds the necessary `JMenuItem`s to the specified menu.

Overrides:
  `addSystemMenuItems` in class `BasicInternalFrameTitlePane`
Parameters:
  `menu` - Menu.

### createButtons

protected void createButtons()

Overrides:
  `createButtons` in class `BasicInternalFrameTitlePane`

### createLayout

protected LayoutManager createLayout()

Overrides:
  `createLayout` in class `BasicInternalFrameTitlePane`

### syncCloseButtonTooltip

protected void syncCloseButtonTooltip()
Synchronizes the tooltip of the close button.

### removeNotify

public void removeNotify()

Overrides:
  `removeNotify` in class `JComponent`

### addNotify

public void addNotify()

Overrides:
  `addNotify` in class `JComponent`

### getCloseButton

public AbstractButton getCloseButton()